/* Problem URL: https://codeforces.com/contest/2133/problem/E */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;

        vvi graph(n);
        vi count(n);
        rep(i, n - 1) {
            int a, b;
            cin >> a >> b;
            a--, b--;

            graph[a].push_back(b);
            graph[b].push_back(a);
            count[a]++;
            count[b]++;
        }

        vi color(n);
        vi rem;
        vi checks;

        function<void(int, int)> dfs = [&](int i, int p) {
            for (auto j : graph[i]) {
                if (j == p) {
                    continue;
                }

                dfs(j, i);
            }

            int g = 0;

            for (auto j : graph[i]) {
                if (j == p) {
                    continue;
                }

                if (color[j] == 1) {
                    color[i] = 2;
                    break;
                }

                if (color[j] == 0) {
                    g++;
                    if (g >= 3) {
                        color[i] = 2;
                        break;
                    }
                }
            }

            if (color[i] == 2) {
                rem.push_back(i + 1);
                for (auto j : graph[i]) {
                    if (color[j] == 2) {
                        continue;
                    }
                    count[j]--;
                    count[i]--;
                }
            } else if (g == 2) {
                color[i] = 1;
            }
        };

        dfs(0, -1);

        V<bool> vis(n);
        function<void(int)> get = [&](int i) {
            vis[i] = true;
            checks.push_back(i + 1);

            if (color[i] == 2) {
                return;
            }

            for (auto j : graph[i]) {
                if (vis[j] || color[j] == 2) {
                    continue;
                }

                get(j);
            }
        };

        rep(i, n) {
            if (vis[i] || count[i] > 1) {
                continue;
            }

            get(i);
        }

        cout << rem.size() + checks.size() << '\n';

        for (auto j : rem) {
            cout << "2 " << j << '\n';
        }

        for (auto j : checks) {
            cout << "1 " << j << '\n';
        }
    }
}
